@ 940Tcrt0.s for the fake-crt0 naked boombastic code in minimal_940t.h
@ Written by rlyeh, 2005.

      .section".init"
      .code 32
      .align
      .global _start
 
_start:
      LDR PC, [pc, #44]              @ Reset
      LDR PC, [pc, #40]              @ Undefined instruction
      LDR PC, [pc, #36]              @ Software Interrupt
      LDR PC, [pc, #32]              @ Prefetch abort
      LDR PC, [pc, #28]              @ Data abort
      LDR PC, [pc, #24]              @ Reserved
      LDR PC, [pc, #20]              @ IRQ
      LDR PC, [pc, #16]              @ FIQ
 
_init:
      LDR   SP, stack               @ Load our stack at 000ffffc
      LDR   IP, deadbeef            @ Load deadbeef
      LDR   FP, leetface            @ Load face0000
      STMDB R13!, {R11,R12}
      .word 0xea000004              @ B realinit   
						@ putting B instead of .word may causes some troubles
						@ in *our* specific circumstances.
ioffset:
      .word  0x00000020
stack:
      .word  0x000ffffc
deadbeef:
      .word  0xdeadbeef			@ Squidge's legacy :-)
leetface:
      .word  0x1ee7face

area1:
      .word 0x100019			

realinit:
      MOV R0, #0x3F                  @ 4Gb page starting at 0x000000
      MCR p15, 0, R0,c6,c0, 0        @ Set as data memory region 0
      MCR p15, 0, R0,c6,c0, 1        @ Set as instruction memory region 0

      LDR R0, area1                  @ 8kb page starting at 0x100000
      MCR p15, 0, R0,c6,c1, 0        @ Set as data memory region 1
      MCR p15, 0, R0,c6,c1, 1        @ Set as instruction memory region 1

      MOV R0, #0x01                  @ Region 0 is cachable/bufferable
      MCR p15, 0, R0,c2,c0, 0        @ Write data cachable bits
      MCR p15, 0, R0,c2,c0, 1        @ Write instruction cachable bits
      MCR p15, 0, R0,c3,c0, 0        @ Write bufferable bits

      MOV R0, #0x0F                  @ Full access in the two areas (read+write)
      MCR p15, 0, R0,c5,c0, 0        @ Write dataspace access permissions
      MCR p15, 0, R0,c5,c0, 1        @ Write inst space access permissions

      MRC p15, 0, R0,c1,c0, 0        @ Read control register
      ORR R0, R0, #1                 @ Protection unit enabled
      ORR R0, R0, #4                 @ DCache enabled
      ORR R0, R0, #0x1000            @ ICache enabled
      ORR R0, R0, #0xC0000000        @ Async clocking + FastBus
      MCR p15, 0, R0,c1,c0, 0        @ Set control register

.pool
.end

