/*
  GP2X minimal library by rlyeh, 2005. emulnation.info@rlyeh (swap it!)

  License
  =======

  Free for non-commercial projects (it would be nice receiving a mail from you).
  Other cases, ask me first.

  GamePark Holdings is not allowed to use this library and/or use parts from it.

  ------------------------------------------------------------------------------

  This is a sub-program example for the 940t coprocessor.

  Usage:

  - Include minimal_940t.h instead of minimal.h. This must to be the first line
    of your subprogram.

  - Use gp2x_dualcore_name_subprogram(name) at last line, and give this
    subprogram a name.

  - Subprograms cannot execute any external C function. That includes libc too.
    In other words, you cannot use memcpy(), printf(), etc... or any external
    C function within this subprogram.

  - You can access the GP2X memory however through gp2x_dualcore_data() macro.

  Each subprogram features a transparent FIFO message system to communicate
  and synchronize both cores.

  - If you want to use the featured FIFO message system between both cores,
    you would have to execute the argument requested, and then exit.

  - If you want a subprogram to be at background and not to communicate with
    the 920t core, just send a dumb message from your 920t to your 940t core,
    do a while(1) in your 940t main() and never return back.
*/


#include "minimal_940t.h"            /*this must be your first line*/

#include "our_shared_data.h"

int gp2x_2ndcore_try(void)
{
  static int a=0;
  return ++a;
}

void main(unsigned long command)
{
 VARIABLE_TESTS=gp2x_2ndcore_try();

 if(command==MESSAGE_INVERT)   VARIABLE_A^=1;
 if(command==MESSAGE_SUBTRACT) VARIABLE_B--;
}


gp2x_dualcore_name_subprogram(940t); /*this must be your last line*/
