/*
  GP2X minimal library by rlyeh, 2005. emulnation.info@rlyeh (swap it!)

  License
  =======

  Free for non-commercial projects (it would be nice receiving a mail from you).
  Other cases, ask me first.

  GamePark Holdings is not allowed to use this library and/or use parts from it.

  ------------------------------------------------------------------------------
  
 Here's the current memory map for our shared area for the current library v0.9:

    range 0x00000000-0x00000FFF (4  kb) is reserved                             
    range 0x00001000-0x00007FFF (8  kb) is free, and non-cacheable              
    range 0x00008000-0x00F00000 (15 Mb) is free, and cacheable                  
*/

/*
 Let's define three variables in the free & noncacheable area.                
 We will use these three pointers to communicate both cores.                  
 Note: the three variables are contigous but since we're working with         
 32 bits pointers we move every 4 bytes.                                       
*/

#define VARIABLE_A          gp2x_dualcore_data(0x1000)
#define VARIABLE_B          gp2x_dualcore_data(0x1004)
#define VARIABLE_TESTS      gp2x_dualcore_data(0x1008)

/*
  Let's define two messages for our communication system.                        
  These numbers have no special meaning here, they're just for identification purposes.
*/

#define MESSAGE_INVERT      0
#define MESSAGE_SUBTRACT    1

